/*
 * SystemDefinitions.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>

#ifndef SYSCTRL_SYSTEMDEFINITIONS_H_
#define SYSCTRL_SYSTEMDEFINITIONS_H_

namespace SYSCTRL
{

#ifndef NOP
#define  NOP   asm(" NOP")
#endif


#ifndef FP_PI
#define FP_PI (float)3.14159265358979323846 // Pi
#endif

#ifndef FP_DAMP_FACTOR
#define FP_DAMP_FACTOR   0.70710678118654752440  // 1/sqrt(2)
#endif



//
// Voltage PLL-ABC Parameters
//
#define PLLABC_FREQUENCY_NOMINAL    (float)(2.0*FP_PI*50.0)
#define PLLABC_FREQUENCY_CUT        (float)(2.0*FP_PI*10.0)
#define PLLABC_FILTER_TIME          (float)(1.0/PLLABC_FREQUENCY_CUT)
#define PLLABC_CONTROLLER_GAIN      (float)(PLLABC_FREQUENCY_CUT/2.0)
#define PLLABC_CONTROLLER_TIME      (float)(4.0/PLLABC_FREQUENCY_CUT)

#define PLLABC_FREQUENCY_LIMIT_HI  PLLABC_FREQUENCY_CUT
#define PLLABC_FREQUENCY_LIMIT_LOW -PLLABC_FREQUENCY_CUT










} /* namespace SYSCTRL */

#endif /* SYSCTRL_SYSTEMDEFINITIONS_H_ */
